// uti1a.h		Lg, July 19, 1995


#ifndef UTI1A_H 
#define UTI1A_H

#include <iostream>
using namespace std;


void error( const char* filename, const char* msg, const char* s2 ="" );
//   =====

void warning( const char* filename, const char* msg ="", const char* s2 ="" );
//   =======

void memory_error();
//   ============

void input_error( long int line, const char* msg, const char* s2="" );
//   ===========                    // line number is suppressed if line<0

void input_warning( long int line, const char* msg, const char* s2="" );
//   =============                  // line number is suppressed if line<0

inline int odd( int n ) { return n & 1; }
//         ===

//////////////////////////////////////////////////////////////////////////////

ostream& adjust_left( ostream& os );
//       ===========

ostream& adjust_right( ostream& os );
//       ============

//////////////////////////////////////////////////////////////////////////////

template<class T> inline void swap( T& x, T& y )
{     //                      ====
    T temp = x; 
    x = y; 
    y = temp;
}

template<class number> number power( number x, int n ) 
{     //                      =====
    if (n<0) { warning("uti1.h", 
               "\"power(int)\" called with negative exponent"); return 1; }
    number z=1; 
    while ( n>0 ) { 
        if ( odd(n) ) { z *= x; } 
        n /= 2; 
        x *= x; 
    }
    return z;
}

template<class number> number gcd( number a, number b )   
{     //                      ===
      //                        "number" is "int" or "long int"
      //                        OBS: returns 0 if both arguments are zero
    if ( a<0 ) a=-a;
    if ( b<0 ) b=-b;
    if ( a==0 ) return b;
    if ( b==0 ) return a;
    int pow2 = 0; 
    while ( !odd(a) && !odd(b) ) {
        pow2++; a>>=1; b>>=1; 
    }
    while ( !odd(a) ) a>>=1;
    while ( !odd(b) ) b>>=1;
    for (;;) {                       // both a and b are odd
        if ( a<b ) swap(a,b); 
        a -= b; 
        if ( a==0 ) return b<<pow2;
        while ( !odd(a) ) a>>=1;
    }
}


#endif
